package Praktikum03;


public class Philosopher implements Runnable {

    protected int id;
    protected final Fork left;
    protected final Fork right;

    public Philosopher(int id, Fork left, Fork right) {
        this.id = id;
        this.left = left;
        this.right = right;
    }

    @Override
    public void run() {

        tryToTakeFork(left);
        tryToTakeFork(right);

        eat();

    }

    protected void eat() {
        System.out.println("Philosopher " + id + " is eating");
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        left.put();
        right.put();
        System.out.println("Philosopher " + id + " finished eating");
    }

    protected void tryToTakeFork(Fork fork) {
        System.out.println("Philosopher " + id + " is trying to get fork " + fork.getId());
        while(!fork.take()){
            Thread.yield();
        }
        System.out.println("Philosopher " + id + " got fork " + fork.getId());
    }


}
